#include <stdio.h>
#include "sqlite3.h"

void sqlite3_eval(sqlite3_context *context, int argc, sqlite3_value **argv) {
	int type = sqlite3_value_type(argv[0]);
	switch(type) {
		case SQLITE_TEXT: {
			const unsigned char *val = sqlite3_value_text(argv[0]);
			char *errmsg;
			sqlite3 *db = sqlite3_context_db_handle(context);
			int rc = sqlite3_exec(db, val, NULL, NULL, &errmsg);
			if(SQLITE_OK != rc && SQLITE_DONE != rc) {
				sqlite3_result_text(context, errmsg, -1, NULL);
				sqlite3_free(errmsg);
			} else {
				sqlite3_result_int(context, sqlite3_changes(db));
			}
			break;
		}
		default: {
			char err[1024];
			snprintf(err, sizeof(err), "eval: don't know what to do with type %i", type);
			sqlite3_result_text(context, err, -1, NULL);
			break;
		}
	}
}

